/* sf28d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__28 = 28;

doublereal sf28d_c(doublereal *x, integer *ierr)
{
    /* Initialized data */

    static doublereal a[19] = { 0.,4.2e-19,3.132e-17,2.06305e-15,
            1.1989083e-13,6.0968928e-12,2.6882812895e-10,1.016972672769e-8,
            3.2609105057896e-7,8.73831549662236e-6,1.92469359688114e-4,
            .00341633176601234,.0477187487981741,.509493365439983,
            4.01167376017935,22.2748192424622,82.4890327440241,
            190.494320172743,255.466879624362 };
    static doublereal c__[26] = { 1e-14,2e-14,0.,-4e-14,-1.1e-13,-1.1e-13,
            1.2e-13,7e-13,1.4e-12,1.11e-12,-2.45e-12,-1.223e-11,-2.896e-11,
            -4.361e-11,-1.954e-11,1.5142e-10,7.8081e-10,2.87935e-9,
            1.045317e-8,4.342656e-8,2.27083e-7,1.57817791e-6,1.527877872e-5,
            2.2510873571e-4,.00627824030274,.79833170337777 };
    static doublereal exp30 = 10686474581524.4;
    static doublereal xmax = 46.499;
    static doublereal sys059 = 1.7e308;

    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double sqrt(doublereal), exp(doublereal);

    /* Local variables */
    static integer i__;
    static doublereal y, z__;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal q1, q2, q3, x1, x2;

    *ierr = 0;
    if (*x < 0.) {
        goto L4;
    }
L1:
    y = abs(*x);
    z__ = y * .125;
    if (z__ > 1.) {
        goto L5;
    }
    if (z__ <= 0.) {
        goto L3;
    }
    x2 = z__ * 4. * z__ - 2.;
    q3 = 0.;
    q2 = 0.;
    for (i__ = 1; i__ <= 19; ++i__) {
        q1 = q2;
        q2 = q3;
/* L2: */
        q3 = x2 * q2 - q1 + a[i__ - 1];
    }
    ret_val = (q3 - q1) * .5;
    goto L10;
L3:
    ret_val = 1.;
    goto L10;
L4:
    *ierr = 1;
    goto L9;
L5:
    z__ = 1. / z__;
    x2 = z__ + z__;
    q3 = 0.;
    q2 = 0.;
    for (i__ = 1; i__ <= 26; ++i__) {
        q1 = q2;
        q2 = q3;
/* L6: */
        q3 = x2 * q2 - q1 + c__[i__ - 1];
    }
    q2 = (q3 - q1) * .5;
    x1 = 1. / sqrt(y);
    if (y < xmax) {
        goto L7;
    }
    *ierr = 65;
    ret_val = sys059;
    goto L9;
L7:
    if (y > 30.) {
        goto L8;
    }
    ret_val = exp(y) * x1 * q2;
    goto L10;
L8:
    ret_val = x1 * exp30 * (q2 * exp(y - 30.));
L9:
    if (*ierr != 0) {
        utsf11_c(ierr, &c__28);
    }
    if (*ierr == 1) {
        goto L1;
    }
L10:
    return ret_val;
} /* sf28d_c */
